/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006 by Witz Corporation, JAPAN
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*	vZbTˑW[ AZuꕔiSH2pj*/
 
#define _MACRO_ONLY
#include "sys_defs.h"

/*	OQƐ錾 */
	.globl	_runtsk
	.globl	_schedtsk
	.globl	_tcxb_pc
	.globl	_tcxb_sp
	.globl	_tinib_task
	.globl	_callevel
	.globl	_runisr
	.globl	_tinib_exepri
	.globl	_tcb_curpri
	.globl	_call_pretaskhook
	.globl	_call_posttaskhook
	.globl	_PreTaskHook
	.globl	_PostTaskHook
	.globl	_lock_flag
	.globl	_intmask

/*	OJ錾 */
	.globl	_dispatch
	.globl	_start_dispatch
	.globl	_exit_and_dispatch
	.globl	_activate_r
	.globl	_interrupt
	.globl	dispatch_r

.section	".text" , "ax"
.align	2

/*
 *	^XNfBXpb`
 *
 *	Ăяo:
 *		݁FIPL=0, FLGWX^Irbg=0 (CPUbN)
 *		ReLXgFcallevel=1(^XNReLXg)
 *		X^bNF ^XNX^bN
*/

_dispatch:
	/* X^bNփWX^ۑ */
	mov.l	 r8 , @-r15
	mov.l	 r9 , @-r15
	mov.l	r10 , @-r15
	mov.l	r11 , @-r15
	mov.l	r12 , @-r15
	mov.l	r13 , @-r15
	mov.l	r14 , @-r15
	sts.l	pr , @-r15
	mov.l	runtsk_adr , r1
	mov.b	@r1 , r0
	extu.b	r0 , r0
	shll2	r0
	mov.l	tcxb_sp_adr , r2
	mov.l	r15 , @(r0 , r2)	/* X^bN|C^TCBɕۑ */
	mov.l	dispatch_r_adr , r3
	mov.l	tcxb_pc_adr , r2	/* sĊJԒnTCBɕۑ */
	mov.l	r3 , @(r0 , r2)
	bra		dispatcher			/* dispatcher */
	nop
	
.align	4
dispatch_r_adr:
	.long	dispatch_r

/*
 *	Ăяo:
 *		݁FIPL=0xf, (CPUbN)
 *		ReLXgFcallevel=1(^XNReLXg)
 *		X^bNF ^XNX^bN
 */

.align	2
dispatch_r:
	/* ^XNX^bN烌WX^A */
	lds.l	@r15+ ,  pr
	mov.l	@r15+ , r14
	mov.l	@r15+ , r13
	mov.l	@r15+ , r12
	mov.l	@r15+ , r11
	mov.l	@r15+ , r10
	mov.l	@r15+ ,  r9
	mov.l	@r15+ ,  r8
	rts						/* dispatch Ăяo֖߂. */
	nop

/*
 *	^XNN
 *	ł, CPUbNԂɂ, ^XNN.
 *
 *	ďo: FLGWX^Irbg=0xf (CPUbN), ^XNX^bN
 *			callevel = 1(^XNReLXg), ^XNX^bN
 */

.align	2
_activate_r:
	mov.l	runtsk_adr	,r2			/* sJn^XNID */
	mov.b	@r2 , r0
	extu.b	r0 , r0
	mov.l	tinib_exepri_adr , r2		/* Dx̓ǂݍ */
	mov.b	@(r0 , r2) , r1
	extu.b	r1 , r1
	mov.l	tcb_curpri_adr , r3		/* ݗDxɐݒ */
	mov.b	r1 , @(r0 , r3)
	
	mov		#0 , r3
	shll2	r0
	mov.l	tinib_task_adr , r1
	mov.l	@(r0 , r1) , r2
	jmp		@r2
	ldc		r3 , sr				/* xXbgA荞݋ */

.align	4
tinib_exepri_adr:
	.long	_tinib_exepri
tcb_curpri_adr:
	.long	_tcb_curpri
tinib_task_adr:
	.long	_tinib_task

/*
 *	dispatcherĂяo:
 *		EׂẴ^XÑReLXg͕ۑĂ.
 *		ESRWX^IPLrbg=0xf (CPUbN),
 *		EReLXg̓J[lN^XNReLXg(callevel=1)
 *				callevel̏l1H
 *		N͔^XNReLXg(callevel=1), ̏ꍇɂΉ.
 *	dispatcher ďõX^bN:
 *		__kernel_dispatch 炫ꍇ: ^XNX^bN
 *		exit_and_dispatch 炫ꍇ: 
 *			exit_task 炫ꍇ̓^XNX^bN
 *			J[lN͊݃X^bN
 *		ret_int 炫ꍇ: ^XNX^bN
 *		dispatcher_1 ł̊ݑ҂炫ꍇ: ݃X^bN
 */

.align	2
_exit_and_dispatch:
dispatcher:
	/* |Xg^XNtbŇĂяo */
	mov.l	PostTaskHook_adr , r0
	tst		r0 , r0
	bt		_start_dispatch
	mov.l	call_posttaskhook_adr , r0
	jsr		@r0
	nop
_start_dispatch:
	mov.l	schedtsk_adr, r0	/* schedtsk  runtsk  */
	mov.b	@r0 , r2
	extu.b	r2 , r2
	mov.l	runtsk_adr , r1
	mov.b	r2 , @r1
	
	mov.l	invalid_tsk , r0
	cmp/eq	r0 , r2		/* schedtsk Ȃ΃ACh[v */
	bt		pre_idle
	shll2	r2
	mov.l	tcxb_sp_adr , r0	
	mov.l	@(r0 , r2) , r15		/* ^XNX^bN|C^𕜋A */
	mov.l	tcxb_pc_adr , r0
	mov.l	@(r0 , r2) , r3
	mov.l	PreTaskHook_adr , r1
	tst		r1 , r1
	bt		PreTaskHook_r
	mov.l	call_pretaskhook_adr , r1
	mov.l	r3 , @-r15		/* PreTaskHookpɖ߂PCX^bNޔ */
	jsr		@r1
	nop
	mov.l	@r15+ , r3		/* ߂PC߂ */
PreTaskHook_r:
	jmp		@r3				/* ߂Ԓn */
	nop

.align	4
_activate_r_adr:
	.long	_activate_r
PreTaskHook_adr:
	.long	_PreTaskHook
PostTaskHook_adr:
	.long	_PostTaskHook
call_pretaskhook_adr:
	.long	_call_pretaskhook
call_posttaskhook_adr:
	.long	_call_posttaskhook

/*
 *	 schedtsk Ȃꍇ
 */
.align	2
pre_idle:
	/*
	 *	Ŕ^XNReLXg,݃X^bNɐ؂芷̂,
	 *	Ŕ銄ݏɂǂ̃X^bNgƂ̉,
	 *	݃nhł̃fBXpb`h~Ƃ2̈ӖD
	 */
	mov.l	int_stack, r15		/* ݗp̃X^bN֐ؑւ */
	mov.l	callevel_adr , r0
	mov		#TCL_ISR2 , r1
	mov.b	r1 , @r0			/* ^XNReLXg */
	/* ACh[v̏ */
	mov		#0 , r2
	mov.l	_lock_flag_adr , r8
	mov.l	r2 , @r8
	mov.l	mask_ipm , r3
	mov.l	schedtsk_adr , r5
	mov.l	invalid_tsk , r4
idle_loop:
	ldc		r2 , sr				/* 荞ݑ҂ */
	nop
	ldc		r3 , sr				/* 荞݋ */
	mov.b	@r5 , r1			/* schedtskǂݏo */
	extu.b	r1 , r1
	cmp/eq	r4 , r1				/* XPW[ׂ^XN邩H */
	bt		idle_loop			/* ĂуACh[v */
	
	mov		#TCL_TASK , r3
	mov.b	r3 , @r0			/* callevel߂ */
	mov		#1 , r2
	mov.l	r2 , @r8
	/* CPUbNԂ */
	xor		r0 , r0
	mov.l	_intmask_adr , r1
	mov.l	r0 , @r1
	mov.l	_lock_flag_adr , r1
	mov		#1 , r0
	mov.l	r0 , @r1
	bra		_start_dispatch		/* fBXpb` */
	nop

/*
 *  ݃nho(fBXpb`v)
 *
 *	ďo:
 *	EFLGWX^IPL=0xf, ^XNReLXg(callevel=1)
 *	EgpX^bN̓^XNX^bN
 *	E^XNReLXgr0-r7,mach,machl,gbr,prX^bNɐς܂ꂽ
 */
	.align	2
	.globl	ret_int
ret_int:
	/* c̃WX^ۑ */
	mov.l	r8 , @-r15
	mov.l	r9 , @-r15
	mov.l	r10 , @-r15
	mov.l	r11 , @-r15
	mov.l	r12 , @-r15
	mov.l	r13 , @-r15
	mov.l	r14 , @-r15
	shll2	r0						/* runtskr0ɓĂ */
	mov.l	tcxb_sp_adr , r1
	mov.l	r15 , @(r0 , r1)		/* X^bN|C^ۑ */
	mov.l	tcxb_pc_adr , r1
	mov.l	ret_int_r_adr , r2		/* ߂Ԓnret_int_rɐݒ */
	mov.l	r2 , @(r0 , r1)			/* X^bN|C^ۑ */
	/* CPUbNԂ */
	xor		r0 , r0
	mov.l	_intmask_adr , r1
	mov.l	r0 , @r1
	mov.l	_lock_flag_adr , r1
	mov		#1 , r0
	mov.l	r0 , @r1
	bra		dispatcher				/* fBXpb` */
	nop

.align	4
ret_int_r_adr:
	.long	ret_int_r
_intmask_adr:
	.long	_intmask
_lock_flag_adr:
	.long	_lock_flag


/*
 *	Ăяo: IPL=0xf, (CPUbN),
 *			callevel=1(^XNReLXg), ^XNX^bN
 *	X^bNɂr14-r8,gbr,mach,machl,pr,r7-r0̏Őς܂Ă
 */
.align	2
ret_int_r:
	mov.l	@r15+ , r14		/* WX^𕜋A */
	mov.l	@r15+ , r13
	mov.l	@r15+ , r12
	mov.l	@r15+ , r11
	mov.l	@r15+ , r10
	mov.l	@r15+ , r9
	mov.l	@r15+ , r8
	ldc.l	@r15+ , gbr
	lds.l	@r15+ , mach
	lds.l	@r15+ , macl
	lds.l	@r15+ , pr
	mov.l	@r15+ , r7
	mov.l	@r15+ , r6
	mov.l	@r15+ , r5
	mov.l	@r15+ , r4
	mov.l	@r15+ , r3
	mov.l	@r15+ , r2
	mov.l	@r15+ , r1
	mov.l	@r15+ , r0
	rte						/* 荞݌֕A */
	nop

/*
 *	ݏo(AZuLq)
 *
 *	ďo:
 *	ESRWX^IPL0xf
 *	EX^bN͑d荞݂Ȃ犄݃X^bN, łȂ
 *	  ^XNX^bN
 *	Er0 ɂ͊݃nh̃AhXi[Ă.
 *	Er1 ɂ͑O̎sIDi[ĂD
 *	Er2 ɂ͊荞ݎtSRWX^̒li[Ă
 *
 *	WX^X^bNɂǂ̂悤ɕۑĂ邩ȉɎ.
 *	̐}ł͏オ, ʂ̃AhX, X^bN͉
 *	ɌĐςݏグ̂Ƃ.
 *
 *	-------------------------
 *	|       R3(4byte)        |
 *	--------------------------
 *	|       R2(4byte)        |
 *	--------------------------
 *	|       R1(4byte)        |
 *	--------------------------
 *	|       R0(4byte)        |
 *	--------------------------
 *	|       SR(4byte)        | <- 荞ݔSRWX^(H/Wɂĕۑ)
 *	--------------------------
 *	|       PC(4byte)        | <- 荞݂畜APC(H/Wɂĕۑ)
 *	--------------------------
 * 
 *  荞݋ʕŎc̃WX^ޔ̃X^bNȉɎD
 *	-------------------------
 *	|      GBR(4byte)        |
 *	-------------------------
 *	|     MACH(4byte)        |
 *	-------------------------
 *	|     MACL(4byte)        |
 *	-------------------------
 *	|       PR(4byte)        |
 *	-------------------------
 *	|       R7(4byte)        |
 *	-------------------------
 *	|       R6(4byte)        |
 *	-------------------------
 *	|       R5(4byte)        |
 *	-------------------------
 *	|       R4(4byte)        |
 *	-------------------------
 *	|       R3(4byte)        |
 *	--------------------------
 *	|       R2(4byte)        |
 *	--------------------------
 *	|       R1(4byte)        |
 *	--------------------------
 *	|       R0(4byte)        |
 *	--------------------------
 *	|       SR(4byte)        | <- 荞ݔSRWX^(H/Wɂĕۑ)
 *	--------------------------
 *	|       PC(4byte)        | <- 荞݂畜APC(H/Wɂĕۑ)
 *	--------------------------
 * 
 *	xfBXpb`vret_intɂăX^bNɐς܂郌WX^
 *	ȉɎD
 *
 *	-------------------------
 *	|      R14(4byte)        |
 *	-------------------------
 *	|      R13(4byte)        |
 *	-------------------------
 *	|      R12(4byte)        |
 *	--------------------------
 *	|      R11(4byte)        |
 *	--------------------------
 *	|      R10(4byte)        |
 *	--------------------------
 *	|       R9(4byte)        |
 *	-------------------------
 *	|       R8(4byte)        |
 *	-------------------------
 *	|     MACH(4byte)        |
 *	-------------------------
 *	|     MACL(4byte)        |
 *	-------------------------
 *	|       PR(4byte)        |
 *	-------------------------
 *	|       R7(4byte)        |
 *	-------------------------
 *	|       R6(4byte)        |
 *	-------------------------
 *	|       R5(4byte)        |
 *	-------------------------
 *	|       R4(4byte)        |
 *	-------------------------
 *	|       R3(4byte)        |
 *	--------------------------
 *	|       R2(4byte)        |
 *	--------------------------
 *	|       R1(4byte)        |
 *	--------------------------
 *	|       R0(4byte)        |
 *	--------------------------
 *	|       SR(4byte)        | <- 荞ݔSRWX^(H/Wɂĕۑ)
 *	--------------------------
 *	|       PC(4byte)        | <- 荞݂畜APC(H/Wɂĕۑ)
 *	--------------------------
 *
 *	nh烊^[, d݂łȂ, 
 *	fBXpb`v鎞(schedtsk != runtsk)ɁC
 *	ret_int ֕򂷂D
 *
 *	d݂ǂcallevel̒lŔ肷.
 *	callevel != 1 ȂΑd݂łƔ肷.
 *
 */
 
.align	2
_interrupt:
	/* c̃X^bNޔ */
	mov.l	r4 , @-r15
	mov.l	r5 , @-r15
	mov.l	r6 , @-r15
	mov.l	r7 , @-r15
	sts.l	pr , @-r15
	sts.l	macl , @-r15
	sts.l	mach , @-r15
	stc.l	gbr , @-r15
	mov		#TCL_TASK , r4		/* d荞݂`FbN */
	mov.l	callevel_adr , r3
	mov.b	@r3 , r5
	cmp/eq	r4 , r5
	bf int_from_int
int_from_task:
	mov.l	int_stack , r4			/* X^bN؂ւ */
	mov.l	r15 , @-r4
	mov		r4 , r15
	mov		#TCL_ISR2 , r6		/* sxύX */
	mov.b	r6 , @r3
int_from_int:
	mov.w	r1 , @-r15		/* O̊荞IDX^bNɕۑ */
	mov.w	r5 , @-r15		/* O̎sxX^bNɕۑ */
							/* Ń[hŕۑĂ̂́A */
							/* SP4oCgEɕۂ߂ł */
	ldc		r2 , sr			/* 荞݋ */
	jsr		@r0				/* 荞݃[`Ăяo */
	nop
	mov.l	mask_ipm , r0	/* 荞݋֎~ */
	ldc		r0 , sr
	mov.w	@r15+ , r0		/* O̎sx𕜋A */
	mov.l	callevel_adr , r1
	mov.b	r0 , @r1
	mov.w	@r15+ , r2		/* O̊荞ID𕜋A */
	mov.l	runisr_adr , r1
	mov.b	r2 , @r1
	mov		#TCL_TASK , r1	/* d荞݂ǂH */
	cmp/eq	r0 , r1
	bf		int_return
	
	/* i̊荞݂畜A鏈 */
	mov.l	@r15 , r15			/* ^XNX^bNɖ߂ */
	mov.l	callevel_adr , r2
	mov.b	r1 , @r2
	
	/* 荞ݓŊ荞݂ĂȂmF */
	mov		r15 , r0
	mov.l	@(52, r0) , r0	/* 荞ݑOSRWX^o */
	mov.l	mask_ipm , r1		/* IPMo */
	and		r1 , r0
	tst		r0 , r0				/* 0ǂ`FbN */
	bf		int_return			/* 0łȂꍇ͑d荞 */
	
	mov.l	runtsk_adr , r1	/* fBXpb`v邩H */
	mov.b	@r1 , r0
	extu.b	r0 , r0
	mov.l	schedtsk_adr , r1
	mov.b	@r1 , r2
	extu.b	r2 , r2
	cmp/eq	r0 , r2
	bf		ret_int
int_return:
	ldc.l	@r15+ , gbr		/* WX^𕜋A */
	lds.l	@r15+ , mach
	lds.l	@r15+ , macl
	lds.l	@r15+ , pr
	mov.l	@r15+ , r7
	mov.l	@r15+ , r6
	mov.l	@r15+ , r5
	mov.l	@r15+ , r4
	mov.l	@r15+ , r3
	mov.l	@r15+ , r2
	mov.l	@r15+ , r1
	mov.l	@r15+ , r0
	rte						/* 荞݌ɕA */
	nop


/* gp݂̏ */
.globl _unused_interrupt
_unused_interrupt:
	rte
	nop

.align	4
runtsk_adr:
	.long	_runtsk
schedtsk_adr:
	.long	_schedtsk
tcxb_sp_adr:
	.long	_tcxb_sp
tcxb_pc_adr:
	.long	_tcxb_pc
int_stack:
	.long	STACK_TOP
callevel_adr:
	.long	_callevel
runisr_adr:
	.long	_runisr
mask_ipm:
	.long	0x000000f0
invalid_tsk:
	.long	INVALID_TASK

/* 萔̒` */
.equ TCL_TASK , 1
.equ TCL_ISR2 , 2
.equ INVALID_TASK , 0xff
	
	

	.end
